## kio-extras 25.04.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Applications Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "25")
set (RELEASE_SERVICE_VERSION_MINOR "04")
set (RELEASE_SERVICE_VERSION_MICRO "3")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.0.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDEGitCommitHooks)

include(ECMMarkNonGuiExecutable)
include(ECMMarkAsTest)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(CheckIncludeFile)
include(CMakePushCheckState)
include(CMakePackageConfigHelpers)
include(FeatureSummary)

option(BUILD_DOC "Whether to build the documentation" ON)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Network Widgets Svg Core5Compat)

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Config
    ConfigWidgets
    CoreAddons
    DNSSD
    I18n
    KIO
    Solid
    GuiAddons
    SyntaxHighlighting
    KCMUtils
    TextWidgets
)

# shall we use DBus?
# enabled per default on Linux & BSD systems
set(USE_DBUS_DEFAULT OFF)
if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    set(USE_DBUS_DEFAULT ON)
endif()
option(USE_DBUS "Build components using DBus" ${USE_DBUS_DEFAULT})
if(USE_DBUS)
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS DBusAddons)
endif()

if(LINUX)
    option(WITH_LIBPROXY "Build with libproxy, required for WPAD problem detection" ON)
endif()
if(WITH_LIBPROXY)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS Notifications)
    find_package(PkgConfig)
    pkg_check_modules(libproxy REQUIRED IMPORTED_TARGET libproxy-1.0)
    add_feature_info("libproxy" libproxy_FOUND "libproxy for WPAD problem detection (kcm_proxy)")
endif()

find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt6Test PROPERTIES
         PURPOSE "Required for tests"
         TYPE OPTIONAL
         )
add_feature_info("Qt6Test" Qt6Test_FOUND "Required for building tests")
if (NOT Qt6Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

find_package(QCoro6 REQUIRED COMPONENTS Core)
qcoro_enable_coroutines()

include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

if (NOT WIN32 AND USE_DBUS)
    option(BUILD_ACTIVITIES "Build recentlyused:/, activities:/ KIO workers and fileitem plugin." ON)
    if(BUILD_ACTIVITIES)
        find_package(Qt6Sql REQUIRED)
        find_package(PlasmaActivities REQUIRED)
        find_package(PlasmaActivitiesStats REQUIRED)
    endif()
endif()

if (BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION})
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

find_package(Phonon4Qt6 4.6.60 NO_MODULE)
set_package_properties(Phonon4Qt6 PROPERTIES
   DESCRIPTION "Qt-based audio library"
   PURPOSE "Required for the audio preview plugin"
   TYPE OPTIONAL)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT WIN32)
    # we need a version of samba which has already smbc_set_context(), Alex
    set(SAMBA_REQUIRE_SMBC_SET_CONTEXT TRUE)
    set(SAMBA_REQUIRE_SMBC_OPTION_SET TRUE)
    find_package(Samba)
    set_package_properties(Samba PROPERTIES DESCRIPTION "the SMB client library, a version with smbc_set_context() and smbc_option_set()"
                        URL "https://www.samba.org/"
                        TYPE OPTIONAL
                        PURPOSE "Needed to build the SMB KIO worker"
                        )
endif()

find_package(libssh 0.8.3 MODULE)
set_package_properties(libssh PROPERTIES DESCRIPTION "the SSH library with SFTP support"
                       URL "https://www.libssh.org/"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the SFTP KIO worker"
                      )

find_package(Libmtp 1.1.2)
set_package_properties(Libmtp PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the MTP KIO worker"
                       )

find_package(IMobileDevice)
set_package_properties(IMobileDevice PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

find_package(PList)
set_package_properties(PList PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

check_include_file(utime.h HAVE_UTIME_H)

# ECM's KDECompilerSettings.cmake should take care of enabling supporting on
# 32bit architectures.
# Thorw a fatal error if off_t isn't >=64bit to ensure that large files are working
# as expected.
# BUG: 165449
if(UNIX)
    check_cxx_source_compiles("
        #include <sys/types.h>
        /* Check that off_t can represent 2**63 - 1 correctly.
            We can't simply define LARGE_OFF_T to be 9223372036854775807,
            since some C++ compilers masquerading as C compilers
            incorrectly reject 9223372036854775807.  */
        #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))

        int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
        int main() { return 0; }
    "
    OFFT_IS_64BIT)

    if(NOT OFFT_IS_64BIT)
        message(FATAL_ERROR "Large file support is not enabled.")
    endif()

    find_package(Gperf)
    set_package_properties(Gperf PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the man KIO worker"
                           )

    find_package(TIRPC)
    set_package_properties(TIRPC PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the NFS KIO worker"
                           )
else()
    # FIXME: on windows we ignore support until trash gets integrated
endif()

ecm_set_disabled_deprecation_versions(
    QT 5.15.2
    KF 6.0
)

add_subdirectory(kcms)

if(BUILD_ACTIVITIES)
  add_subdirectory( activities )
  add_subdirectory( recentlyused )
endif()
add_subdirectory( filter )
if(Phonon4Qt6_FOUND)
    add_subdirectory( kfileaudiopreview )
endif()
add_subdirectory( info )
add_subdirectory( archive )
if (NOT WIN32)
    # does not compile: fish.cpp(41): fatal error C1083: Cannot open include file: 'sys/resource.h': No such file or directory
    # Used for getting the resource limit for closing all child process FDs. Could be completely replaced by fcloseall() if available for Unix or _fcloseall() for Windows, either conditionally on Q_OS_type or using a configure test.
    add_subdirectory( fish )
endif()
add_subdirectory( thumbnail )
if (libssh_FOUND)
    add_subdirectory(sftp)
endif ()

if (NOT WIN32 AND NOT APPLE AND USE_DBUS)
    add_subdirectory( filenamesearch )
endif()

if (Libmtp_FOUND AND USE_DBUS)
  add_subdirectory(mtp)
endif()

if(NOT WIN32)
   if(Gperf_FOUND)
     add_subdirectory( man )
   endif()
   if(TIRPC_FOUND)
     add_subdirectory( nfs )
   endif()
endif()

if(SAMBA_FOUND AND USE_DBUS)
    add_subdirectory(smb)
endif()

if(IMobileDevice_FOUND AND PList_FOUND)
    add_subdirectory(afc)
endif()

configure_file (config-runtime.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-runtime.h )

ecm_qt_install_logging_categories(
    EXPORT KIO_EXTRAS
    FILE kio-extras.categories
    DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
)

if(BUILD_DOC)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

ki18n_install(po)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== afc/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_afc\")

add_library(kio_afc MODULE)
set_target_properties(kio_afc PROPERTIES
    OUTPUT_NAME "afc"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kio"
)

target_sources(kio_afc PRIVATE
    kio_afc.cpp
    afcurl.cpp
    afcutils.cpp
    afcdevice.cpp
    afcclient.cpp
    afcfile.cpp
    afcapp.cpp
    afcdiskusage.cpp
    afcfilereader.cpp
    afcspringboard.cpp
)

ecm_qt_declare_logging_category(kio_afc
    HEADER afc_debug.h
    IDENTIFIER KIO_AFC_LOG
    CATEGORY_NAME kf.kio.workers.afc
    DESCRIPTION "KIO afc"
    EXPORT KIO_EXTRAS
)

target_link_libraries(kio_afc
    KF6::KIOCore
    IMobileDevice::IMobileDevice
    PList::PList
    KF6::I18n
)

install(TARGETS kio_afc DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

install(FILES solid_afc.desktop DESTINATION ${KDE_INSTALL_DATADIR}/solid/actions)
install(FILES afc-network.desktop  DESTINATION ${KDE_INSTALL_DATADIR}/remoteview)

=== archive/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_archive\")

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

set(LIBKIOARCHIVE_VERSION "6.0.0")
set(LIBKIOARCHIVE_SOVERSION "6")
set(LIBKIOARCHIVE_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/KioArchive6")

include(ECMSetupVersion)
ecm_setup_version(${LIBKIOARCHIVE_VERSION} VARIABLE_PREFIX "KIOARCHIVE"
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kioarchive_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KioArchive6ConfigVersion.cmake"
                  SOVERSION ${LIBKIOARCHIVE_SOVERSION})

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KioArchive6")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KioArchive6Config.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchive6Config.cmake"
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchive6Config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchive6ConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KioArchiveTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE KioArchiveTargets.cmake
)

install(FILES
    kio_archivebase.h
    ${CMAKE_CURRENT_BINARY_DIR}/libkioarchive_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/kioarchive_version.h
    DESTINATION ${LIBKIOARCHIVE_INSTALL_INCLUDEDIR}
    COMPONENT Devel
)

ecm_qt_declare_logging_category(kio_archive_debug_SRCS
    HEADER kio_archive_debug.h
    IDENTIFIER KIO_ARCHIVE_LOG
    CATEGORY_NAME kf.kio.workers.archive
    OLD_CATEGORY_NAMES log_kio_archive kf.kio.slaves.archive
    DESCRIPTION "KIO archive"
    EXPORT KIO_EXTRAS
)

############### ArchiveProtocolBase library ###########

add_library(kioarchive6 kio_archivebase.cpp ${kio_archive_debug_SRCS})

include(GenerateExportHeader)
generate_export_header(kioarchive6 BASE_NAME libkioarchive EXPORT_FILE_NAME libkioarchive_export.h)

target_compile_definitions(kioarchive6
    PRIVATE
        -DKIOCORE_DISABLE_DEPRECATED_BEFORE_AND_AT=0x054400 # need to support KIO::detailsToStatDetails
)

target_link_libraries(kioarchive6
    PUBLIC
    KF6::Archive
    KF6::KIOCore
    PRIVATE
    KF6::I18n
    Qt::Network
)

set_target_properties(kioarchive6 PROPERTIES
    VERSION ${KIOARCHIVE_VERSION}
    SOVERSION ${KIOARCHIVE_SOVERSION}
    EXPORT_NAME KioArchive
)

target_include_directories(kioarchive6
    INTERFACE "$<INSTALL_INTERFACE:${LIBKIOARCHIVE_INSTALL_INCLUDEDIR}>"
)

install(TARGETS kioarchive6 EXPORT KioArchiveTargets LIBRARY NAMELINK_SKIP ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

############### Archive Worker ######################

add_library(kio_archive MODULE kio_archive.cpp ${kio_archive_debug_SRCS})
target_link_libraries(kio_archive KF6::KIOCore KF6::Archive kioarchive6 Qt::Network)
set_target_properties(kio_archive PROPERTIES OUTPUT_NAME "archive")
install(TARGETS kio_archive DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

=== mtp/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_mtp\")

cmake_push_check_state()
list(APPEND CMAKE_REQUIRED_INCLUDES Libmtp::Libmtp)
list(APPEND CMAKE_REQUIRED_LIBRARIES Libmtp::Libmtp)
check_symbol_exists(LIBMTP_Get_Children "libmtp.h" HAVE_LIBMTP_Get_Children)
cmake_pop_check_state()

add_subdirectory(shared)
add_subdirectory(kiod_module)

add_library(kio_mtp MODULE)
set_target_properties(kio_mtp PROPERTIES
    OUTPUT_NAME "mtp"
)

target_sources(kio_mtp PRIVATE
    kio_mtp.cpp
)

target_include_directories(kio_mtp PRIVATE shared)
target_link_libraries(kio_mtp kmtp Qt::Core KF6::KIOCore KF6::I18n KF6::DBusAddons)

ecm_qt_declare_logging_category(kio_mtp
    HEADER kio_mtp_debug.h
    IDENTIFIER LOG_KIO_MTP
    CATEGORY_NAME kf.kio.workers.mtp
    OLD_CATEGORY_NAMES kde.kio-mtp kf.kio.slaves.mtp
    DESCRIPTION "KIO mtp"
    EXPORT KIO_EXTRAS
)

install(TARGETS kio_mtp DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

########### install files ###############

install( FILES mtp-network.desktop  DESTINATION  ${KDE_INSTALL_DATADIR}/konqueror/dirtree/remote )
install( FILES solid_mtp.desktop  DESTINATION  ${KDE_INSTALL_DATADIR}/solid/actions )
install( FILES mtp-network.desktop  DESTINATION  ${KDE_INSTALL_DATADIR}/remoteview )

=== nfs/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

## Check for XDR functions
include(CheckCXXSymbolExists)

set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TIRPC_LIBRARIES})
set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${TIRPC_INCLUDE_DIRS})
check_cxx_symbol_exists(xdr_u_int64_t "rpc/xdr.h" HAVE_XDR_U_INT64_T)
check_cxx_symbol_exists(xdr_uint64_t "rpc/xdr.h" HAVE_XDR_UINT64_T)
check_cxx_symbol_exists(xdr_u_hyper "rpc/xdr.h" HAVE_XDR_U_HYPER)
check_cxx_symbol_exists(xdr_u_longlong_t "rpc/xdr.h" HAVE_XDR_U_LONGLONG_T)

if (NOT HAVE_XDR_U_INT64_T AND NOT HAVE_XDR_UINT64_T AND NOT HAVE_XDR_U_HYPER AND NOT HAVE_XDR_U_LONGLONG_T)
    message(FATAL_ERROR "Could not find 64-bit XDR datatype functions!")
endif (NOT HAVE_XDR_U_INT64_T AND NOT HAVE_XDR_UINT64_T AND NOT HAVE_XDR_U_HYPER AND NOT HAVE_XDR_U_LONGLONG_T)

if (HAVE_XDR_U_INT64_T)
    add_definitions(-DHAVE_XDR_U_INT64_T)
endif (HAVE_XDR_U_INT64_T)
if (HAVE_XDR_UINT64_T)
    add_definitions(-DHAVE_XDR_UINT64_T)
endif (HAVE_XDR_UINT64_T)
if (HAVE_XDR_U_HYPER)
    add_definitions(-DHAVE_XDR_U_HYPER)
endif (HAVE_XDR_U_HYPER)
if (HAVE_XDR_U_LONGLONG_T)
    add_definitions(-DHAVE_XDR_U_LONGLONG_T)
endif (HAVE_XDR_U_LONGLONG_T)

# silence warnings for rpcgen generated code having lots of unused variables
set(AVOID_UNUSED_VARIABLE_WARNING_FLAG)
if (CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-unused-variable")
    check_c_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        set(AVOID_UNUSED_VARIABLE_WARNING_FLAG ${_flag})
    endif()
endif()

# silence warnings for use of xdr_void as no-op method in calls of clnt_call()
# It's method signature "bool_t xdr_void(void)" does not match the xdrproc_t definition
# which is "bool_t (*)(XDR*, ...)", and the compiler correctly points that out as issue.
# While no-one has come up so far with a nice way to tell the compiler that cast is fine,
# for now just disable the warning completely for the compilation unit.
set(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG)
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-cast-function-type")
    check_cxx_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        set(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG ${_flag})
    endif()
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"kio6_nfs\")
include_directories(${TIRPC_INCLUDE_DIRS})

add_library(kio_nfs MODULE kio_nfs.cpp nfsv3.cpp rpc_nfs3_prot_xdr.c)
target_link_libraries(kio_nfs KF6::KIOCore KF6::ConfigCore KF6::I18n Qt::Network ${TIRPC_LIBRARIES})
set_target_properties(kio_nfs PROPERTIES OUTPUT_NAME "nfs")

if(AVOID_UNUSED_VARIABLE_WARNING_FLAG)
    set_source_files_properties(rpc_nfs2_prot_xdr.c rpc_nfs3_prot_xdr.c PROPERTIES
        COMPILE_OPTIONS "${AVOID_UNUSED_VARIABLE_WARNING_FLAG}"
    )
endif()

if(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG)
    set_source_files_properties(nfsv3.cpp PROPERTIES
        COMPILE_OPTIONS "${AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG}"
    )
endif()

ecm_qt_declare_logging_category(kio_nfs
    HEADER kio_nfs_debug.h
    IDENTIFIER LOG_KIO_NFS
    CATEGORY_NAME kf.kio.workers.nfs
    OLD_CATEGORY_NAMES kde.kio_nfs kf.kio.workers.nfs
    DESCRIPTION "KIO nfs"
    EXPORT KIO_EXTRAS
)

install(TARGETS kio_nfs DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

########### install files ###############

=== thumbnail/CMakeLists.txt ===
if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"kio6_thumbnail\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

find_package(OpenEXR 3.0 CONFIG QUIET)
if(NOT OpenEXR_FOUND)
    find_package(OpenEXR)
endif()
set_package_properties(OpenEXR PROPERTIES
    DESCRIPTION "A library for handling OpenEXR high dynamic-range image files"
    URL "https://www.openexr.com/"
    TYPE OPTIONAL
    PURPOSE "Provides support for OpenEXR formatted images in the thumbnail KIO worker"
)

find_package(libappimage 0.1.10 CONFIG)
set_package_properties(libappimage PROPERTIES
    DESCRIPTION "Core library of the AppImage project"
    URL "https://github.com/AppImage/libappimage"
    TYPE OPTIONAL
    PURPOSE "Provides support for AppImage thumbnails"
)

option(WITHOUT_X11 "Build without support for XCursor thumbnails (disables finding X11)" OFF)
if (NOT WITHOUT_X11)
    find_package(X11)
    set_package_properties(X11 PROPERTIES
        DESCRIPTION "X11 libraries"
        URL "https://www.x.org"
        TYPE OPTIONAL
        PURPOSE "Provides support for XCursor thumbnails"
    )
endif()

find_package(Taglib 1.11)
set_package_properties(Taglib PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Provides support for audio thumbnails"
)

find_package(KExiv2Qt6)
set_package_properties(KExiv2Qt6 PROPERTIES
    TYPE OPTIONAL
    PURPOSE "Provides support for extracting JPEG thumbnails")
if (KExiv2Qt6_FOUND)
    set(HAVE_KEXIV2 TRUE)
endif()

include_directories(${CMAKE_BINARY_DIR})

include(ECMSetupQtPluginMacroNames)
ecm_setup_qtplugin_macro_names(
    JSON_ARG2
        "EXPORT_THUMBNAILER_WITH_JSON"
    CONFIG_CODE_VARIABLE
        PACKAGE_SETUP_AUTOMOC_VARIABLES
)

configure_file(config-thumbnail.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-thumbnail.h)

########### next target ###############

add_library(kio_thumbnail MODULE)
set_target_properties(kio_thumbnail PROPERTIES
    OUTPUT_NAME "thumbnail"
)

target_sources(kio_thumbnail PRIVATE
    thumbnail.cpp
    imagefilter.cpp
)

ecm_qt_declare_logging_category(kio_thumbnail
    HEADER thumbnail-logsettings.h
    IDENTIFIER KIO_THUMBNAIL_LOG
    CATEGORY_NAME kf.kio.workers.thumbnail
    OLD_CATEGORY_NAMES log_kio_thumbnail kf.kio.slaves.thumbnail
    DESCRIPTION "KIO thumbnail"
    EXPORT KIO_EXTRAS
)

target_link_libraries(kio_thumbnail
    PUBLIC
        KF6::CoreAddons
        KF6::KIOCore
        KF6::KIOWidgets
        KF6::I18n
)

install(TARGETS kio_thumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

########### next target ###############

add_library(imagethumbnail MODULE imagecreator.cpp)

target_link_libraries(imagethumbnail
    KF6::CoreAddons
    KF6::KIOGui
)

install(TARGETS imagethumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target ###############

add_library(jpegthumbnail MODULE jpegcreator.cpp)

kconfig_add_kcfg_files(jpegthumbnail jpegcreatorsettings5.kcfgc)

target_link_libraries(jpegthumbnail
    Qt::Core
    Qt::Gui
    KF6::KIOCore
    KF6::KIOGui
    KF6::I18n
    KF6::ConfigCore
    KF6::ConfigGui
)
if (TARGET KExiv2Qt6)
    target_link_libraries(jpegthumbnail KExiv2Qt6)
endif()

install(FILES jpegcreatorsettings5.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
install(TARGETS jpegthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target ###############

add_library(svgthumbnail MODULE svgcreator.cpp)

target_link_libraries(svgthumbnail
    Qt::Gui
    Qt::Svg
    KF6::KIOCore
    KF6::KIOGui
)

install(TARGETS svgthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target ###############

add_library(textthumbnail MODULE textcreator.cpp)

target_link_libraries(textthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::SyntaxHighlighting
)

install(TARGETS textthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target ###############

if(NOT WIN32)

    add_library(djvuthumbnail MODULE djvucreator.cpp)

    ecm_qt_declare_logging_category(djvuthumbnail
        HEADER thumbnail-djvu-logsettings.h
        IDENTIFIER KIO_THUMBNAIL_DJVU_LOG
        CATEGORY_NAME kf.kio.workers.thumbnail.djvu
        OLD_CATEGORY_NAMES log_kio_thumbnail.djvu kf.kio.slaves.thumbnail.djvu
        DESCRIPTION "DjVu files thumbnailer"
        EXPORT KIO_EXTRAS
    )

    target_link_libraries(djvuthumbnail KF6::KIOGui)

    install(TARGETS djvuthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

endif()

########### next target ###############

if(OpenEXR_FOUND)

    add_library(exrthumbnail MODULE exrcreator.cpp)

    ecm_qt_declare_logging_category(exrthumbnail
        HEADER thumbnail-exr-logsettings.h
        IDENTIFIER KIO_THUMBNAIL_EXR_LOG
        CATEGORY_NAME kf.kio.workers.thumbnail.exr
        OLD_CATEGORY_NAMES log_kio_thumbnail.exr kf.kio.slaves.thumbnail.exr
        DESCRIPTION "EXR images thumbnailer"
        EXPORT KIO_EXTRAS
    )

    target_link_libraries(exrthumbnail
        KF6::KIOCore
        KF6::KIOGui
    )
    if(TARGET OpenEXR::OpenEXR)
        target_link_libraries(exrthumbnail OpenEXR::OpenEXR)
    else()
        target_include_directories(exrthumbnail SYSTEM PRIVATE ${OpenEXR_INCLUDE_DIRS})
        target_link_libraries(exrthumbnail ${OpenEXR_LIBRARIES})
    endif()

    # OpenEXR headers use exceptions; at least clang refuses to build the target
    # when exceptions are not enabled.
    kde_source_files_enable_exceptions(exrcreator.cpp)

    install(TARGETS exrthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

endif()

########### next target ###############

if(X11_Xcursor_FOUND AND NOT WITHOUT_X11)

    add_library(cursorthumbnail MODULE cursorcreator.cpp)

    target_link_libraries(cursorthumbnail
        KF6::KIOCore
        KF6::KIOGui
        KF6::CoreAddons
        ${X11_Xcursor_LIB}
    )

    install(TARGETS cursorthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

endif()

########### next target ###############

add_library(windowsexethumbnail MODULE windowsexecreator.cpp icoutils.cpp exeutils.cpp)
add_library(windowsimagethumbnail MODULE windowsimagecreator.cpp icoutils.cpp exeutils.cpp)

target_link_libraries(windowsexethumbnail KF6::KIOGui)
install(TARGETS windowsexethumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

target_link_libraries(windowsimagethumbnail KF6::KIOGui)
install(TARGETS windowsimagethumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target ###############

add_library(comicbookthumbnail MODULE comiccreator.cpp)

ecm_qt_declare_logging_category(comicbookthumbnail
    HEADER thumbnail-comic-logsettings.h
    IDENTIFIER KIO_THUMBNAIL_COMIC_LOG
    CATEGORY_NAME kf.kio.workers.thumbnail.comic
    OLD_CATEGORY_NAMES log_kio_thumbnail.comic kf.kio.slaves.thumbnail.comic
    DESCRIPTION "Comic books thumbnailer"
    EXPORT KIO_EXTRAS
)

target_link_libraries(comicbookthumbnail
    Qt::Gui
    KF6::Archive
    KF6::KIOGui
)

install(TARGETS comicbookthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

# ########### next target ###############

add_library(kraorathumbnail MODULE kritacreator.cpp)

target_link_libraries(kraorathumbnail
    KF6::KIOGui
    KF6::Archive
)

install(TARGETS kraorathumbnail  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

########### next target #################

if(Taglib_FOUND)

    add_library(audiothumbnail MODULE audiocreator.cpp)

    target_link_libraries(audiothumbnail
        Taglib::Taglib
        KF6::KIOGui
    )

    install(TARGETS audiothumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

endif()

# ########### next target ###############

add_library(opendocumentthumbnail MODULE opendocumentcreator.cpp)

target_link_libraries(opendocumentthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::Archive
)

install(TARGETS opendocumentthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

# ########### next target ###############

if(libappimage_FOUND)

    add_library(appimagethumbnail MODULE appimagecreator.cpp)

    target_link_libraries(appimagethumbnail
        KF6::KIOGui
        Qt::Gui
        libappimage
    )

    install(TARGETS appimagethumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

endif()

# ########### next target ###############

add_library(ebookthumbnail MODULE ebookcreator.cpp)

target_link_libraries(ebookthumbnail
    Qt::Gui
    KF6::KIOGui
    KF6::Archive
)

install(TARGETS ebookthumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

# ########### next target ###############

add_library(directorythumbnail MODULE directorycreator.cpp)

target_link_libraries(directorythumbnail
    Qt::Gui
    KF6::CoreAddons
    KF6::KIOGui
)

install(TARGETS directorythumbnail DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/thumbcreator)

=== kcms/netpref/CMakeLists.txt ===
kcoreaddons_add_plugin(kcm_netpref INSTALL_NAMESPACE "plasma/kcms/systemsettings_qwidgets")

kcmutils_generate_desktop_file(kcm_netpref)
target_sources(kcm_netpref PRIVATE
    netpref.cpp
    ../ksaveioconfig.cpp
)

target_link_libraries(kcm_netpref
  PUBLIC
    KF6::ConfigCore
    KF6::KCMUtils
    KF6::KIOCore
    KF6::TextWidgets # KPluralHandlingSpinBox
  PRIVATE
    KF6::I18n
    KF6::CoreAddons
)

if(USE_DBUS)
  target_link_libraries(kcm_netpref PUBLIC Qt6::DBus)
  target_compile_definitions(kcm_netpref PUBLIC -DWITH_DBUS)
endif()

=== man/tests/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/.. )
include_directories( ${CMAKE_CURRENT_BINARY_DIR}/.. )

########### next target ###############

add_executable(kio_man_test)
ecm_mark_as_test(kio_man_test)
set_target_properties(kio_man_test PROPERTIES
    COMPILE_FLAGS "-DSIMPLE_MAN2HTML -DKIO_MAN_TEST"
)

set(kio_man_test_generated_SRCS)
ecm_gperf_generate(../requests.gperf ${CMAKE_CURRENT_BINARY_DIR}/request_gperf.h kio_man_test_generated_SRCS)

target_sources(kio_man_test PRIVATE
    ${kio_man_test_generated_SRCS}
    kio_man_test.cpp 
    ${CMAKE_CURRENT_SOURCE_DIR}/../man2html.cpp 
    ${CMAKE_CURRENT_SOURCE_DIR}/../request_hash.cpp 
    ${CMAKE_CURRENT_SOURCE_DIR}/../kio_man.cpp 
)

target_link_libraries(kio_man_test Qt::Widgets KF6::I18n KF6::KIOCore KF6::Archive KF6::Codecs Qt::Network kio_man_debug)

if (AVOID_NULLPTR_WARNING_FLAG)
    target_compile_options(kio_man_test PRIVATE ${AVOID_NULLPTR_WARNING_FLAG})
endif()



########### next target ###############

add_executable(man2html )
ecm_mark_as_test(man2html)
set_target_properties(man2html PROPERTIES
    COMPILE_FLAGS -DSIMPLE_MAN2HTML
)

set(man2html_generated_SRCS)
ecm_gperf_generate(../requests.gperf ${CMAKE_CURRENT_BINARY_DIR}/request_gperf.h man2html_generated_SRCS)

target_sources(man2html PRIVATE
    ${man2html_generated_SRCS}
    ${CMAKE_CURRENT_SOURCE_DIR}/../request_hash.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/../man2html.cpp 
)

target_link_libraries(man2html Qt::Core KF6::Codecs KF6::Archive kio_man_debug)

if (AVOID_NULLPTR_WARNING_FLAG)
    target_compile_options(man2html PRIVATE ${AVOID_NULLPTR_WARNING_FLAG})
endif()

=== doc/kioworker/info/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kioworker6/info)

=== debian/changelog ===
kio-extras (4:25.04.3-3) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Rebuild against libplasmaactivities7.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 22 Oct 2025 08:01:26 +0200

kio-extras (4:25.04.3-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Fix build failure with CMake 4 (Closes: #1113079).

 -- Patrick Franz <deltaone@debian.org>  Sat, 06 Sep 2025 12:19:27 +0200

kio-extras (4:25.04.3-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (25.04.3).
    - [thumbnail] Don't create a temporary QApplication to determine the
    platformtheme name. (kde#504126)

 -- Aurélien COUDERC <coucouf@debian.org>  Thu, 24 Jul 2025 08:12:18 +0200

=== debian/control ===
Source: kio-extras
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               gperf,
               libappimage-dev (>= 0.1.10~) [linux-any],
               libimobiledevice-dev,
               libkdsoapwsdiscoveryclient-dev,
               libkexiv2qt6-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6codecs-dev,
               libkf6config-dev (>= 6.0.0~),
               libkf6configwidgets-dev (>= 6.0.0~),
               libkf6coreaddons-dev (>= 6.0.0~),
               libkf6dbusaddons-dev (>= 6.0.0~),
               libkf6dnssd-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6solid-dev (>= 6.0.0~),
               libkf6syntaxhighlighting-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libmtp-dev (>= 1.1.2~),
               libopenexr-dev (>= 3.0~),
               libphonon4qt6-dev (>= 4:4.6.60~),
               libphonon4qt6experimental-dev (>= 4:4.12.0~),
               libplasmaactivities-dev,
               libplasmaactivitiesstats-dev,
               libplist-dev,
               libproxy-dev,
               libsmbclient-dev,
               libssh-dev (>= 0.8.3~),
               libtag-dev (>= 1.11~),
               libtirpc-dev,
               libxcursor-dev,
               pkgconf,
               qcoro-qt6-dev,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0+dfsg~),
               qt6-base-private-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               shared-mime-info (>= 1.3~),
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/network/kio-extras
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kio-extras
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kio-extras.git
Rules-Requires-Root: no

Package: kio-extras
Architecture: any
Depends: kio-extras-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libkf6kcmutils-bin, systemsettings,
Breaks: kio (<< 5.115.0-7~), kio-extras-data (<< 4:24.12.2-2~),
Replaces: kio (<< 5.115.0-7~), kio-extras-data (<< 4:24.12.2-2~),
Description: Extra functionality for kioslaves
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package is part of the KDE base workspace module.

Package: kio-extras-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
Breaks: kio-extras (<< 4:24.12.2-2~), kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Replaces: kio-extras (<< 4:24.12.2-2~), kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Description: Extra functionality for kioslaves data files
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package contains the data files.

## kio-extras 25.07.80

=== debian/changelog ===
kio-extras (4:25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)
  * Drop included upstream patches.

 -- Rik Mills <rikmills@kde.org>  Sat, 12 Jul 2025 18:12:53 +0100

kio-extras (4:25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:45:13 +0100

kio-extras (4:25.04.2-1ubuntu1) questing; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Bump KDE Gear build deps to current version.

 -- Rik Mills <rikmills@kde.org>  Sun, 08 Jun 2025 17:56:01 +0100

kio-extras (4:25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 11:48:06 +0100

kio-extras (4:25.04.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 07 May 2025 22:08:05 +0100

kio-extras (4:25.04.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.0)
  * Build depend on libproxy-dev

 -- Rik Mills <rikmills@kde.org>  Wed, 30 Apr 2025 19:51:13 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: kio-extras
 Section: kde
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Pino Toscano <pino@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 6.0.0~),
                gettext,
                gperf,
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev,
+               libkexiv2qt6-dev (>= 25.07.80~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),
@@ -52,8 +53,8 @@
                shared-mime-info (>= 1.3~),
 Standards-Version: 4.7.2
 Homepage: https://invent.kde.org/network/kio-extras
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kio-extras
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kio-extras.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
 Rules-Requires-Root: no
 
 Package: kio-extras

## kio-extras 25.07.90

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 # KDE Applications Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "04")
-set (RELEASE_SERVICE_VERSION_MICRO "3")
+set (RELEASE_SERVICE_VERSION_MINOR "07")
+set (RELEASE_SERVICE_VERSION_MICRO "90")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})
 
@@ -33,7 +33,11 @@
 
 option(BUILD_DOC "Whether to build the documentation" ON)
 
-find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Network Widgets Svg Core5Compat)
+find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Gui Network Widgets Svg Core5Compat)
+
+if (Qt6Gui_VERSION VERSION_GREATER_EQUAL "6.10.0")
+    find_package(Qt6GuiPrivate REQUIRED)
+endif()
 
 find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
     Archive
@@ -47,7 +51,6 @@
     GuiAddons
     SyntaxHighlighting
     KCMUtils
-    TextWidgets
 )
 
 # shall we use DBus?

=== debian/changelog ===
kio-extras (4:25.07.90-0ubuntu1) questing; urgency=medium

  * New upstream (RC) release (25.07.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Jul 2025 17:47:53 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.07.80~),
+               libkexiv2qt6-dev (>= 25.07.90~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),

## kio-extras 25.08.0

=== debian/changelog ===
kio-extras (4:25.08.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Aug 2025 11:53:21 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.07.90~),
+               libkexiv2qt6-dev (>= 25.08.0~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),

## kio-extras 25.08.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 # KDE Applications Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "25")
-set (RELEASE_SERVICE_VERSION_MINOR "07")
-set (RELEASE_SERVICE_VERSION_MICRO "90")
+set (RELEASE_SERVICE_VERSION_MINOR "08")
+set (RELEASE_SERVICE_VERSION_MICRO "1")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

=== fish/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_fish\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

include(CheckIncludeFiles)
include(CheckFunctionExists)

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(util.h HAVE_UTIL_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(pty.h HAVE_PTY_H)
check_include_files("sys/types.h;libutil.h" HAVE_LIBUTIL_H)
check_function_exists(getpt       HAVE_GETPT)
check_function_exists(grantpt     HAVE_GRANTPT)
include(CheckLibraryExists)
check_library_exists(util  openpty "" HAVE_OPENPTY)
check_library_exists(util  isastream "" HAVE_ISASTREAM)

find_library(UTIL_LIBRARIES util)
mark_as_advanced(UTIL_LIBRARIES)

configure_file(config-fish.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-fish.h)

########### next target ###############
# on Linux there is md5sum, on FreeBSD there is md5
find_program(MD5SUM_EXECUTABLE NAMES md5sum md5 )
    
if (MD5SUM_EXECUTABLE)

   add_library(kio_fish MODULE)
   set_target_properties(kio_fish PROPERTIES
      OUTPUT_NAME "fish"
   )

   if ("${MD5SUM_EXECUTABLE}" MATCHES "md5sum")
      set(CUT_ARG "-f 1")                            # for md5sum the sum is in the 1st column
   else ()
      set(CUT_ARG "-f 4")                            # for md5 the sum is in the 4th column
   endif ()

   if (WIN32)
      set(FISH_GENERATOR "generate_fishcode.bat")
   else ()
      set(FISH_GENERATOR "generate_fishcode.sh")
   endif ()
   set(fishcode_HDR "${CMAKE_CURRENT_BINARY_DIR}/fishcode.h")
   add_custom_command(OUTPUT ${fishcode_HDR}
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${FISH_GENERATOR} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl ${MD5SUM_EXECUTABLE} ${fishcode_HDR} "${CUT_ARG}"
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
   set_source_files_properties(${fishcode_HDR} PROPERTIES SKIP_AUTOMOC TRUE)

   target_sources(kio_fish PRIVATE
      fish.cpp
      ${fishcode_HDR}
   )

   ecm_qt_declare_logging_category(kio_fish
      HEADER loggingcategory.h
      IDENTIFIER KIO_FISH_DEBUG
      CATEGORY_NAME kf.kio.workers.fish
      OLD_CATEGORY_NAMES kio_fish kf.kio.slaves.fish
      DEFAULT_SEVERITY Info
      DESCRIPTION "KIO fish"
      EXPORT KIO_EXTRAS
   )

   target_link_libraries(kio_fish KF6::KIOCore KF6::WidgetsAddons KF6::I18n Qt::Network)

   if (UTIL_LIBRARIES)
      target_link_libraries(kio_fish ${UTIL_LIBRARIES})
   endif ()

   install(TARGETS kio_fish  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio )

endif ()

=== recentlyused/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio6_recentlyused\")

add_library(recentlyused MODULE)
set_target_properties(recentlyused PROPERTIES
    OUTPUT_NAME "recentlyused"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf6/kio"
)
target_sources(recentlyused PRIVATE
    recentlyused.cpp
)
# recentlyused.h has examples in the comment secions which match /*,
# so triggering the preprocessor to warn about nested comments.
# Using a pragma to ignore that diagnostic does not work for preprocessor warnings
# so for now simply that warning is completly disabled
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-comment")
    check_cxx_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        target_compile_options(recentlyused PRIVATE "${_flag}")
    endif()
endif()

ecm_qt_declare_logging_category(recentlyused
    HEADER recentlyused-logsettings.h
    IDENTIFIER KIO_RECENTLYUSED_LOG
    CATEGORY_NAME kf.kio.workers.recentlyused
    OLD_CATEGORY_NAMES log_kio_recentlyused kf.kio.slaves.recentlyused
    DESCRIPTION "KIO recentlyused"
    EXPORT KIO_EXTRAS
)

target_link_libraries(recentlyused
    KF6::KIOCore
    KF6::I18n
    Plasma::Activities
    Plasma::ActivitiesStats)

install(TARGETS recentlyused DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kio)

# forgetfileitemaction plugin
kcoreaddons_add_plugin(forgetfileitemaction
    SOURCES forgetfileitemaction.cpp
    INSTALL_NAMESPACE "kf6/kfileitemaction")

target_link_libraries(forgetfileitemaction
    KF6::I18n
    KF6::KIOWidgets)

=== doc/kioworker/CMakeLists.txt ===
if(KArchive_HAVE_BZIP2)
  add_subdirectory(bzip2)
endif()
add_subdirectory(fish)
add_subdirectory(gzip)
add_subdirectory(info)
add_subdirectory(man)
add_subdirectory(nfs)
add_subdirectory(sftp)
if(NOT WIN32)
  add_subdirectory(smb)
endif()
add_subdirectory(tar)
add_subdirectory(thumbnail)
if(KArchive_HAVE_LZMA)
  add_subdirectory(xz)
endif()
if(KArchive_HAVE_ZSTD)
  add_subdirectory(zstd)
endif()

=== filenamesearch/kded/CMakeLists.txt ===
add_library(filenamesearchmodule MODULE)

target_sources(filenamesearchmodule PRIVATE
     filenamesearchmodule.cpp
)

target_link_libraries(filenamesearchmodule
    KF6::DBusAddons
    KF6::KIOCore
    Qt6::DBus
)

install(TARGETS filenamesearchmodule DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf6/kded)

=== kcms/trash/CMakeLists.txt ===
add_library(kcm_trash MODULE)
target_sources(kcm_trash PRIVATE
    kcmtrash.cpp
)
target_link_libraries(kcm_trash
   KF6::I18n
   KF6::KCMUtils
   KF6::KIOCore
   KF6::Solid
 )

if(USE_DBUS)
  target_link_libraries(kcm_trash Qt6::DBus)
  target_compile_definitions(kcm_trash PUBLIC -DWITH_DBUS)
endif()

if(APPLE)
    target_link_libraries(kcm_trash "-framework DiskArbitration -framework CoreFoundation")
endif(APPLE)

kcmutils_generate_desktop_file(kcm_trash)
install(TARGETS kcm_trash DESTINATION ${KDE_INSTALL_PLUGINDIR})

=== mtp/shared/CMakeLists.txt ===
configure_file(config-mtp.h.cmake config-mtp.h @ONLY)

add_library(kmtp STATIC)

set_source_files_properties(org.kde.kmtp.storage.xml PROPERTIES
    INCLUDE kmtpfile.h
)

set_source_files_properties(org.kde.kmtp.Lister.xml PROPERTIES
    INCLUDE kmtpfile.h
)

set(kmtp_dbus_SRCS)
qt_add_dbus_interfaces(kmtp_dbus_SRCS
    org.kde.kmtp.daemon.xml
    org.kde.kmtp.device.xml
    org.kde.kmtp.storage.xml
    org.kde.kmtp.Lister.xml
)

target_sources(kmtp PRIVATE
    kmtpdinterface.cpp
    kmtpdeviceinterface.cpp
    kmtpstorageinterface.cpp
    kmtpfile.cpp
    ${kmtp_dbus_SRCS}
)
set_property(TARGET kmtp PROPERTY POSITION_INDEPENDENT_CODE ON)
# NOTE: do not link libmtp, we only want it used in the kiod_module, not the kio worker
target_link_libraries(kmtp Qt::Core Qt::DBus)

=== doc/kcontrol6/proxy/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kcontrol6/proxy)

=== doc/kcontrol6/webshortcuts/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kcontrol6/webshortcuts)

=== doc/kioworker/thumbnail/CMakeLists.txt ===
########### install files ###############
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR kioworker6/thumbnail)

=== kcms/proxy/wpad-detector/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: 2024 Harald Sitter <sitter@kde.org>

kcoreaddons_add_plugin(wpad-detector SOURCES module.cpp INSTALL_NAMESPACE "kf6/kded")
target_link_libraries(wpad-detector
    KF6::I18n
    KF6::ConfigCore
    KF6::DBusAddons
    KF6::Notifications
    KF6::CoreAddons
    Qt6::Network
)

add_executable(wpad-detector-helper main.cpp)
target_link_libraries(wpad-detector-helper PkgConfig::libproxy)
install(TARGETS wpad-detector-helper DESTINATION ${KDE_INSTALL_LIBEXECDIR})

=== debian/changelog ===
kio-extras (4:25.08.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 11 Sep 2025 07:08:45 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
                libkdsoapwsdiscoveryclient-dev,
-               libkexiv2qt6-dev (>= 25.08.0~),
+               libkexiv2qt6-dev (>= 25.08.1~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6codecs-dev,
                libkf6config-dev (>= 6.0.0~),
